//
//	Encoder for G.729A CS-ACELP Speech Codec
// 
//		dec_fixed_codebook_search.cpp : Module for 
//			- [A.4.1.4] Decoding Fixed Codebook
//

#include "StdAfx.h"
#include "dec_fixed_codebook_search.h"

void dec_fixed_codebook(int S, int C, int T, float beta, float c[40])
{
	int n;
	int m0, m1, m2, m3;
	bool s0, s1, s2, s3, jx;
	
	s3 = S/8;
	S = S - 8*s3;
	s2 = S/4;
	S = S - 4*s2;
	s1 = S/2;
	S = S - 2*s1;
	s0 = S;

	jx = (C/512)%2;
	m3 = ((C/512)/2)*5+3+jx;
	C = C - 512*(2*(m3/5)+jx);
	m2 = (C/64)*5+2;
	C = C - 64*(m2/5);
	m1 = (C/8)*5+1;
	C = C - 8*(m1/5);
	m0 = C*5;	

	for (n=0; n<40; n++)
		c[n] = 0;
	c[m0] = 2*s0-1;
	c[m1] = 2*s1-1;
	c[m2] = 2*s2-1;
	c[m3] = 2*s3-1;

	if (T<40)
		for (n=T; n<40; n++)
			c[n] += beta*c[n-T];
}
 