//
//	Decoder for G.729A CS-ACELP Speech Codec
// 
//		decoder.cpp : Main program for the decoder 
//

#include "StdAfx.h"
#include "decoder.h"
#include "file_io.h"
#include "initialization.h"
#include "LP_analysis.h"
#include "post_processing.h"
#include "bits.h"
#include "dec_codebook_search.h"

int main(int argc, char* argv[])
{

	int fileLen;

	//short *x_in, *y_out;

	int n;
	int freq = 0;
	int read;
	float a_h[2][10];
	float q[2][10];
	float q_sf[2][10];
	float w[10];

	short *In, *Out;
	
	FILE *Infile=NULL, *Outfile=NULL;
	int size = 0;
	FILE *fin;
	int i,j;
	int current;

	int head=0;
	float r[240], h[80], x[80];
	float s_w[320];
	int T1, T2;	
	int P0, P1, P2;
	float g_p1 = 0.8, g_p2=0.8;
	float v[80], u[240], y[80], c[80];
	int S1, S2, C1, C2;
	float beta = 0.8;
	float g_c1, g_c2;
	float U_h[4] = {-14.0, -14.0, -14.0, -14.0};
	float g = 1;

	float s_h[90], s_ltp[90], sf[90], sf_p[90];
	float s[240];
	FILE *fin2; 
	int pos;

	short test[80];

	char foname[15][35];
	strcpy(foname[0],"reconstructed.dat");	
	strcpy(foname[1],"iLSF1.dat");
	strcpy(foname[2],"iLSF2.dat");
	strcpy(foname[3],"rLP_synthesis1.dat");
	strcpy(foname[4],"rLP_synthesis2.dat");

	FILE *fout[NUM_FILE];
/*		
	for (i=0; i<=4; i++)
		fout[i] = fopen(foname[i],"w");
*/
	if (argc != 2)
	{
		printf("\nA program to decode to a 8kHz, 16-bit PCM wave file using CS-ACELP");
		printf("\nUsage: decoder [destination output wave file]");
	}
	else
	{

		//Opening input and output file
		if ((Infile = fopen("coded_parameter.dat", "rb")) == NULL)
		{
			printf("Error opening file reading\n");
			exit(-1);
		}
		else if ((Outfile = fopen(argv[1], "wb")) == NULL)
		{
			printf("Error opening file for writing\n");
			fclose(Infile);
			exit(-1);	
		}
		
		//Write Header to file Outfile
		createHeader(Outfile);

		//Allocate and initialize the memory
		short x_in[BUFFERSIZE];
		short y_out[BUFFERSIZE];
		for (n=0;n<240;n++)
		{
			x_in[n] = 0;
			y_out[n] = 0;
			u[n] = 0;
		}

		for (n=0; n<90; n++)
		{			
			s_h[n] = 0;
			s_ltp[n] = 0;
			sf[n] = 0;
			sf_p[n] = 0;
			y_out[n] = 0;
			test[n] = 0;
		}
		for (n=0; n<240; n++)
		{
			s[n] = 0;
			r[n] = 0;
		}

		In = x_in;
		Out = &y_out[10];
//		Out = test;
		n = 0;
		fileLen = 0;
		

		//Read in the initial frame
		
/*
		postprocessing(y_out, x_in, n, SUBFRAMESIZE);
		n   = (n+SUBFRAMESIZE)%BUFFERSIZE;
		fileLen += fwrite(Out, sizeof(short), SUBFRAMESIZE, Outfile);
		In  = x_in + n;
		Out = y_out + n;	
*/
/*
		for (i=0; i<SUBFRAMESIZE; i++)
			fprintf(fout[0], "%f\n", (float) Out[i]);

		fin = fopen("LSF.dat","r");
*/		

		current = 0;
		initialize(q[current]);

		while(!(feof(Infile)))
		{
			ReadFromFile(Infile, w, &P0, &P1, &P2, &C1, &S1, &C2, &S2, &g_p1, &g_c1, &g_p2, &g_c2);
			//All the other processes
			//....

			dec_codebook_search(u, P0, P1, P2, S1, S2, C1, C2, g_p1, g_c1, g_p2, g_c2, &beta, &T1, &T2);
			
			current = 1 - current;
			for (i=0; i<10; i++)
			{
				q[current][i] = cos(w[i]);
			}		
			interpolate_LSP(q, current, q_sf);
			LSP2LP(q_sf[0], a_h[0]);
			LSP2LP(q_sf[1], a_h[1]);
			
			for (i=10; i<50; i++)
			{
				s_h[i] = u[80+i-10];
				for (j=0; j<10; j++)				
					s_h[i] -= a_h[0][j] * s_h[i-j-1];								
				//y_out[i-10] = (short) s_h[i];
			}
			for (i=50; i<90; i++)
			{
				s_h[i] = u[80+i-10];
				for (j=0; j<10; j++)				
					s_h[i] -= a_h[1][j] * s_h[i-j-1];
				//y_out[i-10] = (short) s_h[i];
			}
			
			for (i=0; i<10; i++)
				s_h[i] = s_h[i+FRAMESIZE];

			for (i=0; i<80; i++)
				s[i+160] = s_h[i+10];

			post(T1, T2, a_h, s, s_ltp, sf, sf_p, y_out, &g, r);			

			for (i=0; i<160; i++)
			{
				s[i] = s[i+80];
				r[i] = r[i+80];
			}

//			postprocessing(y_out, x_in, n, FRAMESIZE);	
//			write_data(q_sf, a_h, fout);	

//			n   = (n+FRAMESIZE)%BUFFERSIZE;
			for (i=0; i<80; i++)
				test[i] = (short) s_h[i+10];
			fileLen += fwrite(Out, sizeof(short), FRAMESIZE , Outfile);
/*		
			for (i=0; i<FRAMESIZE; i++)
				fprintf(fout[0], "%f\n", (float) Out[i]);			
*/
//			In  = x_in + n;
//			Out = y_out + n;

		}

		//All the other processes
		//....
//		postprocessing(y_out, x_in, n, read);	

//		current = 1 - current;
//		for (i=0; i<10; i++)
//		{
//			fscanf(fin, "%f\n", &w[i]);
//			q[current][i] = cos(w[i]);
//		}				
//		interpolate_LSP(q, current, q_sf);
//		LSP2LP(q_sf[0], a_h[0]);
//		LSP2LP(q_sf[1], a_h[1]);
//		write_data(q_sf, a_h, fout);

//		n   = (n+read)%BUFFERSIZE;
//		fileLen += fwrite(Out, sizeof(short), read, Outfile);
/*		for (i=0; i<read; i++)
			fprintf(fout[0], "%f\n", (float) Out[i]);			
		for (i=read; i<FRAMESIZE; i++)
			fprintf(fout[0], "%f\n", 0);			
*/
		printf("The decoder input are the files:\n");
		printf("  1) parameter.dat  [The encoded parameters]\n");
//		printf("  2) LSF.dat     [The Line Spectral Frequencies of each frame]\n");
		printf("The decoder output is the wave file %s\n",argv[1]);
//		printf("All other data files are created for the Matlab demo\n");

		writeFilesize(Outfile, fileLen);
		
//		fclose(fin);
		fclose(Outfile);
		fclose(Infile);		
//		for (i=0; i<=4; i++)
//			fclose(fout[i]);
	}

	return 0;	
}
