//
//	Decoder for G.729A CS-ACELP Speech Codec
// 
//		file_io.cpp : Module for 
//			- writing the 8kHz, 16-bit PCM to .wav file
//			- saving intermediate files
//

#include "StdAfx.h"
#include "file_io.h"


int write_data(float q_sf[2][10], float a_h[2][10], FILE *fout[NUM_FILE])
{
	int i;

	for (i=0; i<10; i++)
	{		
		fprintf(fout[1],"%f\n",acos(q_sf[0][i]));
		fprintf(fout[2],"%f\n",acos(q_sf[1][i]));
		fprintf(fout[3],"%f\n",a_h[0][i]);
		fprintf(fout[4],"%f\n",a_h[1][i]);
	}

	return 0;
}


//Create the wave file header information
void createHeader(FILE *Outfile)
{
	fwrite("RIFF", sizeof(char), 4, Outfile);
	fwrite("\x00\x00\x00\x00", sizeof(char), 4, Outfile);   //file size
	fwrite("WAVEfmt ", sizeof(char), 8, Outfile);
	fwrite("\x12\x00\x00\x00", sizeof(char), 4, Outfile);	//fmt length
	fwrite("\x01\x00\x01\x00", sizeof(char), 4, Outfile);   //tage and channel
	fwrite("\x40\x1F\x00\x00", sizeof(char), 4, Outfile);	//sample rate
	fwrite("\x80\x3E\x00\x00", sizeof(char), 4, Outfile);	//bits/second
	fwrite("\x02\x00\x10\x00", sizeof(char), 4, Outfile);   //blockalign and bits/sample
	fwrite("\x00\x00", sizeof(char), 2, Outfile);
	fwrite("fact", sizeof(char), 4, Outfile);
	fwrite("\x04\x00\x00\x00", sizeof(char), 4, Outfile);	//fact length
	fwrite("\x00\x00\x00\x00", sizeof(char), 4, Outfile);	//sizeof data/2
	fwrite("data", sizeof(char), 4, Outfile);
	fwrite("\x00\x00\x00\x00", sizeof(char), 4, Outfile);	//sizeof data
}


void writeFilesize(FILE *Outfile, int fileLen)
{
	unsigned char bit0, bit1, bit2, bit3;

	int len = fileLen*2+50;
	char s[] = "0000";

	bit3 = len / SIXTEEN6;
	len  = len % SIXTEEN6;
	bit2 = len / SIXTEEN4;
	len  = len % SIXTEEN4;
	bit1 = len / SIXTEEN2;
	len  = len % SIXTEEN2;
	bit0 = len;
	fseek(Outfile, 4, SEEK_SET);
	fprintf(Outfile, "%c%c%c%c", bit0, bit1, bit2, bit3);

	len  = fileLen;
	bit3 = len / SIXTEEN6;
	len  = len % SIXTEEN6;
	bit2 = len / SIXTEEN4;
	len  = len % SIXTEEN4;
	bit1 = len / SIXTEEN2;
	len  = len % SIXTEEN2;
	bit0 = len;
	fseek(Outfile, 46, SEEK_SET);
	fprintf(Outfile, "%c%c%c%c", bit0, bit1, bit2, bit3);

	len  = fileLen*2;
	bit3 = len / SIXTEEN6;
	len  = len % SIXTEEN6;
	bit2 = len / SIXTEEN4;
	len  = len % SIXTEEN4;
	bit1 = len / SIXTEEN2;
	len  = len % SIXTEEN2;
	bit0 = len;
	fseek(Outfile, 54, SEEK_SET);
	fprintf(Outfile, "%c%c%c%c", bit0, bit1, bit2, bit3);

}
