//
//	Encoder for G.729A CS-ACELP Speech Codec
// 
//		pre_processing.cpp : Module for 
//			- [A.3.1] Pre-processing
//

#include "StdAfx.h"
#include "pre_processing.h"


void preprocessing(short *y, short *x, int n, int length)
{
	int i;
	int n0, n1, n2;

	for (i=n; i<(n+length) ; i++)
	{
		n0 = (i+BUFFERSIZE)   % BUFFERSIZE;
		n1 = (i-1+BUFFERSIZE) % BUFFERSIZE;
		n2 = (i-2+BUFFERSIZE) % BUFFERSIZE;
		y[n0] = (short)(B0*(double)x[n0] + B1*(double)x[n1] + B2*(double)x[n2]+
				 A1*(double)y[n1] + A2*(double)y[n2]);
	}
}
