//
//	Encoder for G.729A CS-ACELP Speech Codec
// 
//		pre_processing.cpp : Module for 
//			- [A.3.1] Pre-processing
//

#include "StdAfx.h"
#include "pre_processing.h"


void preprocessing(short *y, short *x, int start, int length)
{
	int i;
	int n0, n1, n2;

	for (i=start; i<(start+length) ; i++)
	{
		n0 = (i+240)   % 240;
		n1 = (i-1+240) % 240;
		n2 = (i-2+240) % 240;
		y[n0] = (short)(B0*(double)x[n0] + B1*(double)x[n1] + B2*(double)x[n2]+
				 A1*(double)y[n1] + A2*(double)y[n2]);
	}
}
